## mia 2.2.3

=== CMakeLists.txt ===
#
# This file is part of MIA - a toolbox for medical image analysis 
# Copyright (c) Leipzig, Madrid 1999-2014 Gert Wollny
#
# MIA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.
#

PROJECT("mia")

CMAKE_MINIMUM_REQUIRED(VERSION 2.8.5 FATAL_ERROR)

if(COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW)
  cmake_policy(SET CMP0012 NEW)
endif(COMMAND cmake_policy)

include(FindPkgConfig)
include(CheckCXXSourceCompiles)

# Making releases:
#   MICRO_VERSION += 1;
#   INTERFACE_AGE += 1;
#   BINARY_AGE += 1;
# if any functions have been added, set INTERFACE_AGE to 0.
# if backwards compatibility has been broken,
# set BINARY_AGE and INTERFACE_AGE to 0.


SET(VENDOR "Gert Wollny")
SET(PACKAGE_NAME "mia")
SET(MAJOR_VERSION 2)
SET(MINOR_VERSION 2)
SET(MICRO_VERSION 3)
SET(INTERFACE_AGE 0)
SET(BINARY_AGE    3)

SET(PACKAGE_VERSION "${MAJOR_VERSION}.${MINOR_VERSION}.${MICRO_VERSION}")
SET(VERSION "${MAJOR_VERSION}.${MINOR_VERSION}")
SET(MIA_NAME "${PACKAGE_NAME}-${VERSION}")
SET(prefix ${CMAKE_INSTALL_PREFIX})
SET(PLUGIN_OUTPUT "${CMAKE_BINARY_DIR}/plugins")

SET(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

MATH(EXPR MIA_CURRENT "${MICRO_VERSION} - ${BINARY_AGE}")
SET(MIA_REVISION ${INTERFACE_AGE})
MATH(EXPR MIA_AGE "${BINARY_AGE} - ${INTERFACE_AGE}")

SET(LIBRARY_SOVERSION_INFO "${MIA_CURRENT}")
SET(LIBRARY_VERSION_INFO "${MIA_CURRENT}.${MIA_AGE}.${MIA_REVISION}")

OPTION(STRICT_DEPENDECIES "require that all requested optinal dependencies are availabe" FALSE)
OPTION(ALWAYS_CREATE_DOC "Create all documentation during the normal build process (normally you need to run 'make doc')" TRUE)
OPTION(BUILD_EXAMPLES "Build example plug-ins and programs" FALSE)
OPTION(ENABLE_DEBUG_MESSAGES "Enable debug and trace outputs" TRUE)

INCLUDE(GNUInstallDirs)

INCLUDE (CheckIncludeFiles)
INCLUDE (TestBigEndian)
INCLUDE (${CMAKE_CURRENT_SOURCE_DIR}/cmake/macros.cmake)
INCLUDE (${CMAKE_CURRENT_SOURCE_DIR}/cmake/pluginmacro.cmake)
INCLUDE (CheckTypeSize)

include(CheckCXXCompilerFlag)

IF(UNIX)
  CHECK_CXX_COMPILER_FLAG("-std=c++11" HAS_GNU_CXX11_FLAG)
  IF(HAS_GNU_CXX11_FLAG)
    SET(CXX_11_FLAG "-std=c++11")
  ELSE(HAS_GNU_CXX11_FLAG)
    CHECK_CXX_COMPILER_FLAG("-std=c++0x" HAS_GNU_CXX0X_FLAG)
    IF(HAS_GNU_CXX0X_FLAG)
      SET(CXX_11_FLAG "-std=c++0x")
    ELSE(HAS_GNU_CXX0X_FLAG)
      MESSAGE(WARNING "Don't know how to enable C++11, if you are lucky, they are enabled by default")
    ENDIF(HAS_GNU_CXX0X_FLAG)
  ENDIF(HAS_GNU_CXX11_FLAG)
  
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  ${CXX_11_FLAG}")
ENDIF(UNIX)

INCLUDE (${CMAKE_CURRENT_SOURCE_DIR}/cmake/checkCpp0xAuto.cmake)
INCLUDE (${CMAKE_CURRENT_SOURCE_DIR}/cmake/checkCpp0xLambda.cmake)
INCLUDE (${CMAKE_CURRENT_SOURCE_DIR}/cmake/checkSSEAttributeVectorCanUseSubscript.cmake)


IF(NOT "${CXX_HAS_CXX_0X_AUTO}" OR NOT CXX_HAS_CXX_0X_LAMBDA)
  MESSAGE(FATAL_ERROR 
    "This source code requires the C++0x auto type and lambda features. "
    "If your compiler is supposed to support this feature, "
    "please enable the appropriate flags and delete the CMakeCache.txt file before "
    "re-running cmake.\n"
    "For g++ >= 4.6 this is '-std=c++0x' ")
ENDIF(NOT "${CXX_HAS_CXX_0X_AUTO}" OR NOT CXX_HAS_CXX_0X_LAMBDA)

INCLUDE (${CMAKE_CURRENT_SOURCE_DIR}/cmake/checkAltivecEnabled.cmake)
INCLUDE (${CMAKE_CURRENT_SOURCE_DIR}/cmake/checkSSEEnabled.cmake)

ASSERT_SIZE(char 1)
ASSERT_SIZE(short 2)
ASSERT_SIZE(int 4)
ASSERT_SIZE(float 4)
ASSERT_SIZE(double 8)

CHECK_TYPE_SIZE(long LONG_TYPE_SIZE)


IF (${LONG_TYPE_SIZE} EQUAL 8)
  SET(LONG_64BIT TRUE)
ELSE(${LONG_TYPE_SIZE} EQUAL 8)
  SET(LONG_64BIT FALSE)
ENDIF(${LONG_TYPE_SIZE} EQUAL 8)

TEST_BIG_ENDIAN(WORDS_BIGENDIAN)
CHECK_INCLUDE_FILES (unistd.h HAVE_UNISTD_H)
CHECK_INCLUDE_FILES (sys/ioctl.h HAVE_SYS_IOCTL_H)

# find additional packages
#
# With MSVC using pre-installed dynamic libraries is usually a pain because of
# the incompatibilities in the compiler flags
#
IF (MSVC)
  SET(SEARCH_LIBS_DEFAULT FALSE)
ELSE(MSVC)
  SET(SEARCH_LIBS_DEFAULT TRUE)
ENDIF (MSVC)


# Taken from ITK:
# On Visual Studio 8 MS deprecated C. This removes all 1.276E1265 security
# warnings
IF(MSVC)
  ADD_DEFINITIONS(
    -D_CRT_FAR_MAPPINGS_NO_DEPRECATE
    -D_CRT_IS_WCTYPE_NO_DEPRECATE
    -D_CRT_MANAGED_FP_NO_DEPRECATE
    -D_CRT_NONSTDC_NO_DEPRECATE
    -D_CRT_SECURE_NO_DEPRECATE
    -D_CRT_SECURE_NO_DEPRECATE_GLOBALS
    -D_CRT_SETERRORMODE_BEEP_SLEEP_NO_DEPRECATE
    -D_CRT_TIME_FUNCTIONS_NO_DEPRECATE
    -D_CRT_VCCLRIT_NO_DEPRECATE
    -D_SCL_SECURE_NO_DEPRECATE
    -D_SECURE_SCL=0
    )
ENDIF(MSVC)

SET(SOURCE_ROOT "${CMAKE_CURRENT_SOURCE_DIR}")
SET(BUILD_ROOT "${CMAKE_CURRENT_BINARY_DIR}")
SET(LIB_ROOT_INSTALL_PATH "${CMAKE_INSTALL_FULL_LIBDIR}/${MIA_NAME}")
SET(CONFIG_INSTALL_PATH "${LIB_ROOT_INSTALL_PATH}/config")
SET(LIB_INCLUDE_INSTALL_PATH "${LIB_ROOT_INSTALL_PATH}/include")
SET(PLUGIN_INSTALL_PATH "${LIB_ROOT_INSTALL_PATH}/plugins")
SET(PLUGIN_SEARCH_PATH "${PLUGIN_INSTALL_PATH}")
SET(DOC_INSTALL_PATH "share/doc/${MIA_NAME}")
SET(FULL_DOC_INSTALL_PATH "${CMAKE_INSTALL_PREFIX}/${DOC_INSTALL_PATH}")
SET(BINARY_INSTALL_PATH "${CMAKE_INSTALL_BINDIR}")
SET(LIBRARY_INSTALL_PATH "${CMAKE_INSTALL_LIBDIR}")
SET(INCLUDE_INSTALL_PATH "${CMAKE_INSTALL_INCLUDEDIR}/${MIA_NAME}")
SET(MIA_DOCTOOLS_INSTALL_ROOT "${CMAKE_INSTALL_PREFIX}/share/mia-doctools")

######################################################################################
#
# Handle BOOST
#
#
MACRO(GET_BOOST_LINKERFLAG VAR LIBNAMES)
  FOREACH(L  ${LIBNAMES})
    STRING(REGEX MATCH "boost_[-_a-z0-9]*" temp ${L})
    STRING(LENGTH "${temp}" TEMP_LENGTH)
    IF(${TEMP_LENGTH})
      SET(flags "${flags} -l${temp}")
    ENDIF(${TEMP_LENGTH})
  ENDFOREACH(L  ${LIBNAMES})
  
  SET(${VAR} "${flags}")
ENDMACRO(GET_BOOST_LINKERFLAG)

SET(BOOST_COMPONENTS   filesystem  regex unit_test_framework serialization system)
IF (WIN32)
  SET(BOOST_COMPONENTS  ${BOOST_COMPONENTS} date_time)
ENDIF(WIN32)

FIND_PACKAGE( Boost 1.46.1 COMPONENTS
  ${BOOST_COMPONENTS}
  REQUIRED)

INCLUDE_DIRECTORIES(${Boost_INCLUDE_DIR})
LINK_DIRECTORIES(${Boost_LIBRARY_DIRS})

ADD_DEFINITIONS(-DBOOST_ALL_DYN_LINK)
ADD_DEFINITIONS(-DBOOST_FILESYSTEM_VERSION=3)

SET(BOOST_DEPS  ${Boost_REGEX_LIBRARY}  ${Boost_FILESYSTEM_LIBRARY} ${Boost_SYSTEM_LIBRARY})
SET(BOOST_UNITTEST  ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY})

IF (WIN32 AND NOT UNIX)
   FOREACH(l 
       ${Boost_REGEX_LIBRARIES}
       ${Boost_FILESYSTEM_LIBRARY}
       ${Boost_SYSTEM}
       ${Boost_DATE_TIME}
       )
      STRING(REGEX MATCH "lib$" head ${l})
      STRING(COMPARE EQUAL "xlib" "x${head}" islib)
      IF (${islib})
	  STRING(REGEX REPLACE "lib$" "dll" lDLL ${l})
	  INSTALL(FILES ${lDLL} DESTINATION "bin")
      ENDIF(${islib})
   ENDFOREACH(l)
ENDIF (WIN32 AND NOT UNIX)

IF (MSYS OR MINGW)
  SET(BASELIBS ${BOOST_DEPS})
ENDIF (MSYS OR MINGW)

#
# end BOOST 
#
################################################################################

################################################################################
#
# Intel Threading Building Blocks 
# 
FIND_PACKAGE(TBB REQUIRED)
IF(TBB_FOUND) 
  include_directories(${TBB_INCLUDE_DIRS})
  link_directories(${TBB_LIBRARY_DIRS})
ELSE(TBB_FOUND) 
  MESSAGE(FATAL " TBB not found")
ENDIF(TBB_FOUND)
#
# End Intel Threading Building Blocks 
#
################################################################################

################################################################################
#
# Intel Threading Building Blocks 
# 

SET(CMAKE_THREAD_PREFER_PTHREAD ON) 
FIND_PACKAGE(Threads)

IF(CMAKE_USE_PTHREADS_INIT)
  set(PTHREADLIB -lpthread)
ENDIF(CMAKE_USE_PTHREADS_INIT)

################################################################################
# 
# Handle the GNU Scientific Library, this might be a showstopper 
# on MS windows when using Visual C++ 
#
PKG_CHECK_MODULES(GSL REQUIRED gsl)
INCLUDE_DIRECTORIES(${GSL_INCLUDE_DIRS})
LINK_DIRECTORIES(${GSL_LIBRARY_DIRS})


PKG_CHECK_MODULES(EIGEN3 REQUIRED eigen3)
INCLUDE_DIRECTORIES(${EIGEN3_INCLUDE_DIRS})
LINK_DIRECTORIES(${EIGEN3_LIBRARY_DIRS})


################################################################################
# 
# search for some blas
# 

FIND_PACKAGE(BLAS)
IF (NOT BLAS_LIBRARIES) 
  MESSAGE(FATAL_ERROR "A library that implements the BLAS interface is required") 
ENDIF(NOT BLAS_LIBRARIES) 

IF(UNIX)
  GET_BOOST_LINKERFLAG(BOOST_LIBFLAG "${BOOST_DEPS}")
  SET(MIA_DEPEND_LIBRARIES "${BOOST_LIBFLAG} ${BLAS_LIBRARIES} ${TBB_LIBRARIES} ${PTHREADLIB} -ldl")
ENDIF(UNIX)


ADD_DEFINITIONS(-DHAVE_BLAS)
#
# End BLAS 
# 
##################################################################################

##################################################################################
#
# Find gzip for man page compression 
#
find_program(GZIP gzip)
IF(NOT GZIP) 
  MESSAGE(gzip not found, man pages will not be compressed)
ENDIF(NOT GZIP) 

##################################################################################
#
# take care of modules loading infrastructure
#
IF(NOT WIN32)

  FIND_LIBRARY(DL dl
    PATH
    /lib
    /usr/lib
    /opt/local/lib
    /sw/lib
  )
  IF(DL_NOTFOUND)
    MESSAGE(FATAL_ERROR "non-windows systems without libdl.so are not yet supported")
  ENDIF(DL_NOTFOUND)
  SET(BASELIBS  ${BOOST_DEPS} ${PTHREADLIB} ${DL})
ENDIF(NOT WIN32)
SET(PLUGSUFFIX ".mia")

OPTION(WARN_MISSING_OR_OLD_PLUGINTESTS "Warn if plugins don't provided tests or use the old buildsystem to do so" OFF)
#
#
#
##################################################################################

##################################################################################
#
# FFTW related tests 
#
pkg_check_modules(FFTWF REQUIRED fftw3f)
IF(FFTWF_FOUND)
    INCLUDE_DIRECTORIES(${FFTWF_INCLUDE_DIRS})
    LINK_DIRECTORIES(${FFTWF_LIBRARY_DIRS})
    SET(PKG_CONFIG_DEPS "${PKG_CONFIG_DEPS} fftw3f")
ENDIF(FFTWF_FOUND)

MARK_AS_ADVANCED(WITH_FFTWD)
OPTION(WITH_FFTWD "Use double precision FFTW if found" ON)

IF(WITH_FFTWD)
  pkg_check_modules(FFTWD fftw3 REQUIRED)
  IF(FFTWD_FOUND)
    INCLUDE_DIRECTORIES(${FFTWD_INCLUDE_DIRS})
    LINK_DIRECTORIES(${FFTWD_LIBRARY_DIRS})
    SET(PKG_CONFIG_DEPS "${PKG_CONFIG_DEPS} fftw3")
  ENDIF(FFTWD_FOUND)
ENDIF(WITH_FFTWD)
#
#
####################################################################################

####################################################################################
#
# add xml library for loading/storing segmentations and document creation  
#
pkg_check_modules(XMLPP libxml++-2.6 REQUIRED)
IF (XMLPP_FOUND)
  INCLUDE_DIRECTORIES(${XMLPP_INCLUDE_DIRS})
  LINK_DIRECTORIES(${XMLPP_LIBRARY_DIRS})
  SET(PKG_CONFIG_DEPS "${PKG_CONFIG_DEPS} libxml++-2.6")
  SET(HAVE_LIBXMLPP 1)
ENDIF (XMLPP_FOUND)

#
# end XML 
# 
###################################################################################

###################################################################################
#
# Look for IT++ for FastICA
#
OPTION(WITH_ITPP "Use IT++ for some additional features" ${SEARCH_LIBS_DEFAULT})
IF(WITH_ITPP)
  
  IF (STRICT_DEPENDECIES)
    pkg_check_modules(ITPP itpp REQUIRED)
  ELSE (STRICT_DEPENDECIES)
    pkg_check_modules(ITPP itpp)
  ENDIF(STRICT_DEPENDECIES)
  
  IF(ITPP_FOUND)
    INCLUDE_DIRECTORIES(${ITPP_INCLUDE_DIRS})
    LINK_DIRECTORIES(${ITPP_LIBRARY_DIRS})
    SET(PKG_CONFIG_DEPS "${PKG_CONFIG_DEPS} itpp")
    SET(CMAKE_REQUIRED_LIBRARIES ${ITPP_LIBRARIES})

=== doc/CMakeLists.txt ===
#
# This file is part of MIA - a toolbox for medical image analysis 
# Copyright (c) Leipzig, Madrid 1999-2014 Gert Wollny
#
# MIA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.
#


INCLUDE (${CMAKE_ROOT}/Modules/FindDoxygen.cmake)


ADD_CUSTOM_TARGET(docs echo "creating documentation")
add_dependencies(doc docs)  

SET(MIADOCTOOLS_FILES 
  miareadxml.py  
  miawritprogram.py  
  MiaDoctools.cmake
  __init__.py
  )

SET(MIADOCTOOLS_PYTHON_EXE
  miaxml2man.py  
  miaxml2nipype.py  
  miaxml2sgml.py
  )

INSTALL(FILES ${MIADOCTOOLS_FILES} DESTINATION ${MIA_DOCTOOLS_INSTALL_ROOT})

INSTALL(PROGRAMS ${MIADOCTOOLS_PYTHON_EXE} DESTINATION ${MIA_DOCTOOLS_INSTALL_ROOT})


IF(CREATE_USERDOC) 

  ##################################################################
  #  for html userref xsltproc and the style sheet is needed
  #
  find_program(XSLTPROC xsltproc)
  IF(XSLTPROC)
    FIND_PATH(HTML_CHUNK_FILEPATH chunk.xsl
      PATHS 
      /usr/share/sgml/docbook/xsl-stylesheets/html/
      /usr/share/xml/docbook/stylesheet/docbook-xsl/html/
      DOC "style sheet for the creation of the user reference"
      )
  ELSE (XSLTPROC)
    IF(STRICT_DEPENDECIES)
      MESSAGE(ERROR ": xsltproc not found and STRICT_DEPENDECIES set")
    ENDIF(STRICT_DEPENDECIES)
  ENDIF(XSLTPROC)
  
  IF(HTML_CHUNK_FILEPATH) 
    #
    # handle the linking of some files to run the 
    # 
    ADD_CUSTOM_TARGET(userref_outdir mkdir -p ${CMAKE_CURRENT_BINARY_DIR}/userref)
    ADD_CUSTOM_TARGET(userref_css 
      cp  ${CMAKE_CURRENT_SOURCE_DIR}/progref.css 
      ${CMAKE_CURRENT_BINARY_DIR}/userref/progref.css DEPENDS userref_outdir)

    ADD_CUSTOM_COMMAND(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/progref.xml
      COMMAND ln ARGS -sf ${CMAKE_CURRENT_SOURCE_DIR}/progref.xml ${CMAKE_CURRENT_BINARY_DIR}/progref.xml) 

    ADD_CUSTOM_TARGET(progref_link DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/progref.xml)

    ADD_CUSTOM_COMMAND(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/program.xml 
      COMMAND ${PYTHON_EXECUTABLE} ARGS ${CMAKE_CURRENT_SOURCE_DIR}/miaxml2sgml.py ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR}
      DEPENDS xmldoc
      )
    
    ADD_CUSTOM_TARGET(process_xml DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/program.xml)

      
    ADD_CUSTOM_COMMAND(OUTPUT  "userref.stamp"
      COMMAND  
      ${XSLTPROC} ARGS 
      --param chunk.section.depth 3 
      --param chunk.first.sections 1 
      --param use.id.as.filename 1 
      --stringparam html.stylesheet  progref.css 
      --output "userref/" 
      ${HTML_CHUNK_FILEPATH}/chunk.xsl progref.xml
      COMMAND touch ARGS userref.stamp
      DEPENDS process_xml userref_css userref_outdir progref_link ${CMAKE_CURRENT_BINARY_DIR}/program.xml ) 
    
    ADD_CUSTOM_TARGET(userref DEPENDS userref.stamp)
    add_dependencies(docs userref)
    
    ####################################################
    #
    # installation of the user reference 
    IF(ALWAYS_CREATE_DOC) 
      INSTALL(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/userref DESTINATION ${DOC_INSTALL_PATH}/)
      CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/mia2-doc.desktop.cmake ${CMAKE_CURRENT_BINARY_DIR}/mia2-doc.desktop)
      INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/mia2-doc.desktop DESTINATION ${CMAKE_INSTALL_PREFIX}/share/applications)
    ENDIF(ALWAYS_CREATE_DOC)     
  ENDIF(HTML_CHUNK_FILEPATH) 
  
ENDIF(CREATE_USERDOC)

IF (DOXYGEN_FOUND)
  ADD_CUSTOM_TARGET(LibraryDoc echo "creating user library documentation")
  ADD_DEPENDENCIES(docs LibraryDoc)
  
  IF(DOXYGEN_DOT_FOUND)
    SET(HAVE_DOT YES)
  ENDIF(DOXYGEN_DOT_FOUND)
  CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/reference.dox.cmake 
    ${CMAKE_CURRENT_BINARY_DIR}/reference.dox)
  
  ADD_CUSTOM_COMMAND(SOURCE COMMAND ${DOXYGEN_EXECUTABLE}
    ARGS  "${CMAKE_CURRENT_BINARY_DIR}/reference.dox"
    TARGET LibraryDoc
    OUTPUTS libdoc)
  
  IF(ALWAYS_CREATE_DOC) 
    INSTALL(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/libdoc/html/ DESTINATION ${DOC_INSTALL_PATH}/libdoc/)
    CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/libmia2-doc.desktop.cmake ${CMAKE_CURRENT_BINARY_DIR}/libmia2-doc.desktop)
    INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/libmia2-doc.desktop DESTINATION ${CMAKE_INSTALL_PREFIX}/share/applications)
  ENDIF(ALWAYS_CREATE_DOC)     
 
ENDIF (DOXYGEN_FOUND)

=== src/CMakeLists.txt ===
#
# This file is part of MIA - a toolbox for medical image analysis 
# Copyright (c) Leipzig, Madrid 1999-2014 Gert Wollny
#
# MIA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.
#
#

ADD_CUSTOM_TARGET(xmldoc)

INCLUDE (${CMAKE_SOURCE_DIR}/doc/MiaDoctools.cmake)

SET(NIPYPE_INTERFACE_INIT_FILE ${CMAKE_CURRENT_BINARY_DIR}/__init__.py)
MIA_PREPARE_AUTODOC(mia)

ADD_CUSTOM_TARGET(mandir COMMAND mkdir -p ${CMAKE_BINARY_DIR}/doc/man)

LINK_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR}/../mia/core)
LINK_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR}/../mia/2d)
LINK_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR}/../mia/3d)

#basic helpers 
DEFEXE(filenumberpattern  miacore  )
DEFEXE(cmeans             miacore  )
DEFEXE(labelsort          miacore  )
DEFEXE(wavelettrans       miacore  )
DEFEXE(myowavelettest     miacore  )

#2D programs 
DEFEXE(2dimagefilter      mia2d )
DEFEXE(2dcost             mia2d )
DEFEXE(2ddistance         mia2d )
DEFEXE(multihist          mia2d )
DEFEXE(2dimagestats       mia2d )
DEFEXE(2dimagefilterstack mia2d )
DEFEXE(2dimagecreator     mia2d )
DEFEXE(2dimagecombiner    mia2d )
DEFEXE(raw2image          mia2d )
DEFEXE(2ddeform           mia2d )
DEFEXE(2dtransform        mia2d )
DEFEXE(2dforce            mia2d )
DEFEXE(2davgmasked        mia2d )
DEFEXE(2dimageregistration mia2d )
DEFEXE(2dimageselect      mia2d )
DEFEXE(2dimagecombine-dice mia2d )
DEFEXE(2dfuzzysegment     mia2d )
DEFEXE(2dsegment-ahmed    mia2d )
DEFEXE(2dsegment-fuzzyw   mia2d )
DEFEXE(2dmultiimagevar    mia2d )
DEFEXE(2dmultiimageregistration    mia2d )
DEFEXE(2dmulti-force      mia2d )
DEFEXE(2dimagefullstats   mia2d )
DEFEXE(2dbinarycombine    mia2d )
DEFEXE(2dtransformation-to-strain mia2d)
DEFEXE(2dimageseries-maximum-intensity-projection mia2d) 

DEFCHKEXE(2dlerp mia2d )


#Programs related to 2D myocardic perfusion 

DEFEXE(2dsegshift             mia2dmyocardperf )
DEFEXE(2dsegshiftperslice     mia2dmyocardperf )
DEFEXE(2dsegseriesstats       mia2dmyocardperf )
DEFEXE(2dseries2dordermedian  mia2dmyocardperf )
DEFEXE(2dmyoserial-nonrigid   mia2dmyocardperf )
DEFEXE(2dmyoperiodic-nonrigid mia2dmyocardperf )
DEFEXE(2dseriescorr           mia2dmyocardperf )
DEFEXE(2dseriesgradvariation  mia2dmyocardperf )
DEFEXE(2dseriesgradMAD        mia2dmyocardperf )
DEFEXE(2dseriessmoothgradMAD  mia2dmyocardperf )
DEFEXE(2dsegmentcropbox       mia2dmyocardperf )
DEFEXE(2dseghausdorff         mia2dmyocardperf )
DEFEXE(2dserieshausdorff      mia2dmyocardperf )
DEFEXE(2dsegcompare           mia2dmyocardperf )
DEFEXE(2dgroundtruthreg       mia2dmyocardperf )
DEFEXE(2dseries2sets          mia2dmyocardperf )
DEFEXE(2dseries-segdistance   mia2dmyocardperf )
DEFEXE(2dseries-mincorr       mia2dmyocardperf )

DEFEXE(2dseries-sectionmask   mia2dmyocardperf )
DEFEXE(2dmyoseries-dice       mia2dmyocardperf )
DEFEXE(2dmyoseries-compdice   mia2dmyocardperf )
DEFEXE(2dmyocard-segment      mia2dmyocardperf )
DEFEXE(2dmyopgt-nonrigid      mia2dmyocardperf )
DEFEXE(2dmany2one-nonrigid    mia2dmyocardperf )
DEFEXE(2dmyoset-all2one-nonrigid    mia2dmyocardperf )

IF(ITPP_FOUND) 
  DEFEXE(2dmyoica-full      mia2dmyocardperf )
  DEFEXE(2dmyoicapgt        mia2dmyocardperf )
  DEFEXE(2dmyomilles            mia2dmyocardperf )
  DEFEXE(2dmyocard-ica          mia2dmyocardperf )
  DEFEXE(2dmyocard-icaseries    mia2dmyocardperf )
  DEFEXE(2dmyoica-nonrigid      mia2dmyocardperf )
  DEFEXE(2dmyoica-nonrigid-parallel      mia2dmyocardperf )
  DEFEXE(2dmyoica-nonrigid2     mia2dmyocardperf )
  SET(PERF_AND_3D_LIBS mia3d mia2dmyocardperf) 
  DEFEXE(2dseriestovolume  "${PERF_AND_3D_LIBS}")
ENDIF(ITPP_FOUND)

DEFEXE(2dgrayimage-combine-to-rgb mia2d)
DEFEXE(2deval-transformquantity mia2d)
DEFEXE(2dtrackpixelmovement mia2d )

DEFCHKEXE(3dlerp mia3d )

DEFEXE(2dmultiimageto3d   mia3d )
DEFEXE(3dimagestats       mia3d )
DEFEXE(3dcost             mia3d )
DEFEXE(3ddistance         mia3d )
DEFEXE(3dimagefilter      mia3d )
DEFEXE(3dimagecombine     mia3d )
DEFEXE(3dimagecreator     mia3d )
DEFEXE(3dimagefilterstack mia3d )
DEFEXE(raw2volume         mia3d )
DEFEXE(3dcrispsegment     mia3d )
DEFEXE(3ddeform           mia3d )
DEFEXE(3dforce            mia3d )
DEFEXE(3dfuzzysegment     mia3d )
DEFEXE(3dgetslice         mia3d )
DEFEXE(3dgetsize          mia3d )
DEFEXE(2dto3dimage        mia3d )
DEFEXE(2dto3dimageb       mia3d )
DEFEXE(3drigidreg         mia3d )
DEFEXE(3dnonrigidreg      mia3d )
DEFEXE(3dnonrigidreg-alt  mia3d )
DEFEXE(2dstackfilter      mia3d )
DEFEXE(3dtransform        mia3d )
DEFEXE(3dmaskseeded       mia3d )
DEFEXE(3dfield2norm       mia3d )
DEFEXE(3dimageselect      mia3d )
DEFEXE(3dbrainextractT1   mia3d )
DEFEXE(3dbinarycombine    mia3d )
DEFEXE(3ddistance-stats   mia3d )
DEFEXE(3dimageaddattributes  mia3d )
DEFEXE(3dvectorfieldcreate  mia3d )
DEFEXE(3dserial-nonrigid  mia3d )
DEFEXE(3dmany2one-nonrigid  mia3d )
DEFEXE(3dprealign-nonrigid mia3d )
DEFEXE(3dseries-track-intensity mia3d )
DEFEXE(3dtransform2vf mia3d )
DEFEXE(3dtrackpixelmovement mia3d )
DEFEXE(3dvf2transform mia3d )
DEFEXE(3dvfcompare mia3d )
DEFEXE(3deval-transformquantity mia3d)
DEFEXE(3dcost-translatedgrad mia3d)
DEFEXE(3dsegment-ahmed    mia3d)
DEFEXE(3dcombine-mr-segmentations mia3d)

DEFEXE(3dlandmarks-transform mia3d)
DEFEXE(3dlandmarks-distances mia3d)

DEFEXE(plugin-help miamesh )
DEFEXE(meshdistance-to-stackmask miamesh )
DEFEXE(meshfilter miamesh )

ADD_EXECUTABLE(mia-test-plugins-as-installed test_plugins_as_installed.cc)  
TARGET_LINK_LIBRARIES(mia-test-plugins-as-installed miamesh)
TARGET_LINK_LIBRARIES(mia-test-plugins-as-installed ${BOOST_UNITTEST})
IF(WIN32)
  SET_TARGET_PROPERTIES(test-3d-${name} PROPERTIES LINKER_FLAGS "/NODEFAULTLIB:MSVCRT")
ENDIF(WIN32)


IF(ITPP_FOUND) 
  DEFEXE(3dmotioncompica-nonrigid mia3d )
ENDIF(ITPP_FOUND) 

ADD_SUBDIRECTORY(fluid2d  )
ADD_SUBDIRECTORY(fluid3d  )
ADD_SUBDIRECTORY(isosurface  )

=== addons/tiff/CMakeLists.txt ===
#
# This file is part of MIA - a toolbox for medical image analysis 
# Copyright (c) Leipzig, Madrid 1999-2014 Gert Wollny
#
# MIA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.
#

OPTION(WITH_TIFF "enable support for TIFF gray scale images IO and RGB saving" ${SEARCH_LIBS_DEFAULT})

IF(WITH_TIFF)
  IF(STRICT_DEPENDECIES)
    FIND_PACKAGE(TIFF REQUIRED)
  ELSE(STRICT_DEPENDECIES)
    FIND_PACKAGE(TIFF)
  ENDIF(STRICT_DEPENDECIES)
ENDIF(WITH_TIFF)

IF(TIFF_FOUND)
  DEFINE_PROPERTY(GLOBAL PROPERTY HAVE_TIFF_PROP BRIEF_DOCS "yeah" FULL_DOCS "yeah")
  SET(TIFF_LINK_LIBS ${MIA2DLIBS} ${TIFF_LIBRARIES})
  PLUGIN_WITH_PREFIX2("2dimage" "io" tiff "${TIFF_LINK_LIBS}")
  INCLUDE_DIRECTORIES(${TIFF_INCLUDE_DIR})
ENDIF(TIFF_FOUND)

=== examples/2d/CMakeLists.txt ===
#
# This file is part of MIA - a toolbox for medical image analysis 
# Copyright (c) Leipzig, Madrid 1999-2014 Gert Wollny
#
# MIA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.
#


ADD_SUBDIRECTORY(filter)

=== mia/core/CMakeLists.txt ===
#
# This file is part of MIA - a toolbox for medical image analysis 
# Copyright (c) Leipzig, Madrid 1999-2014 Gert Wollny
#
# MIA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.
#

SET(MIACORE_SRC_BASE 
  attributes.cc 
  attribute_names.cc 
  boundary_conditions.cc
  callback.cc 
  cost.cc 
  combiner.cc
  cmdlineparser.cc
  cmdoption.cc
  cmdstringoption.cc
  cmdbooloption.cc
  creator.cc
  datapool.cc
  distance.cc
  dlloader.cc
  dummyhandler.cc
  file.cc 
  filetools.cc 
  filter.cc
  fixedwidthoutput.cc
  fft1d_r2c.cc 
  fftslopeclassifier.cc
  flagstring.cc
  fullstats.cc
  handlerbase.cc
  history.cc
  index.cc
  info.cc
  splinekernel.cc
  interpolator1d.cc
  iodata.cc
  ioplugin.cc
  labelmap.cc
  mitestimages.cc
  module.cc
  msgstream.cc 
  minimizer.cc
  nccsum.cc 
  noisegen.cc 
  optionparser.cc 
  optparam.cc 
  paramoption.cc  
  parameter.cc  
  pixeltype.cc 
  plugin_base.cc  
  product_base.cc
  productcache.cc
  property_flags.cc
  probmap.cc
  regmodel.cc
  revision.cc 
  scaler1d.cc
  seriesstats.cc 
  selftestcmdoption.cc
  shape.cc 
  slopestatistics.cc
  slopeclassifier.cc
  spacial_kernel.cc 
  splineparzenmi.cc
  sqmin.cc
  streamredir.cc
  testplugin.cc 
  threadedmsg.cc
  typedescr.cc
  utils.cc 
  watch.cc 
  waveletslopeclassifier.cc
  )

SET(MIACORE_HEADER_BASE
  attributes.hh
  attribute_names.hh 
  attributetype.hh
  boundary_conditions.hh
  bfsv23dispatch.hh
  callback.hh
  cmdbooloption.hh
  cmdlineparser.hh
  cmdoption.hh
  cmdoptionflags.hh
  cmdstringoption.hh
  combiner.hh
  cost.hh
  cost.cxx
  combiner.hh
  creator.hh
  cstplan.hh
  datapool.hh
  defines.hh
  delayedparameter.hh
  dictmap.hh
  distance.hh
  dlloader.hh
  dummyhandler.hh
  errormacro.hh
  export_handler.hh
  factory.hh
  factory_trait.hh
  fft1d_r2c.hh
  fftslopeclassifier.hh
  fifofilter.hh
  file.hh
  filetools.hh
  filter.hh
  fixedwidthoutput.hh
  flagstring.hh
  fullstats.hh
  handlerbase.hh
  handler.cxx handler.hh
  history.hh
  histogram.hh
  index.hh
  import_handler.hh
  iodata.hh
  iohandler.cxx iohandler.hh
  ioplugin.cxx ioplugin.hh
  kmeans.hh
  labelmap.hh
  meanvar.hh
  mitestimages.hh
  module.hh
  msgstream.hh
  minimizer.hh
  noisegen.hh
  nccsum.hh
  optionparser.hh
  optparam.hh
  parameter.cxx parameter.hh
  paramoption.hh
  pixeltype.hh
  plugin_base.cxx plugin_base.hh
  probmap.hh
  property_flags.hh
  product_base.hh
  productcache.hh
  refholder.hh
  regmodel.hh
  scaler1d.hh
  shape.hh shape.cxx
  seriesstats.hh
  selftestcmdoption.hh
  singular_refobj.hh
  slopestatistics.hh
  slopeclassifier.hh
  slopevector.hh
  splinekernel.hh
  splineparzenmi.hh
  spacial_kernel.hh
  sparse_solver.hh
  sqmin.hh
  statistics.hh
  streamredir.hh
  svector.hh
  testplugin.hh
  threadedmsg.hh
  tools.hh
  traits.hh
  transformation.hh
  typedescr.hh
  type_traits.hh
  utils.hh
  vector.hh
  watch.hh
  waveletslopeclassifier.hh
  )

SET(MIACORETEST_SRC 
  test_core.cc
  test_cost.cc
  test_filter.cc
  test_kernels.cc
  test_optparam.cc
  test_optionparser.cc
  test_parameter.cc
  test_pixeltype.cc
  test_register.cc
  test_sqmin.cc
  test_streamredir.cc
  test_dictmap.cc
  test_fifofilter.cc
  test_probmap.cc
)

IF(ITPP_FOUND)
  SET(ITPP_SRC 
    ica.cc 
    )
  SET(ITPP_HEADER 
    ica.hh
    ica_template.hh ica_template.cxx
    )
ENDIF(ITPP_FOUND)

IF(PWPDF_FOUND) 
  SET(PWPDF_SRC 
    pwh.cc
    )
  SET(PWPDF_HEADER 
    pwh.hh
    )
ENDIF(PWPDF_FOUND) 

MACRO(CORE_TEST name)
  ADD_EXECUTABLE(test-${name} test_${name}.cc)  
  TARGET_LINK_LIBRARIES(test-${name} ${MIACORE} ${BOOST_UNITTEST})
  ADD_TEST(core-${name} test-${name})
  IF(WIN32)
    SET_TARGET_PROPERTIES(test-${name} PROPERTIES LINKER_FLAGS "/NODEFAULTLIB:MSVCRT")
  ENDIF(WIN32)
ENDMACRO(CORE_TEST name)

#
# create the revision retrival code
#
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/revision.hh.cmake ${CMAKE_CURRENT_BINARY_DIR}/revision.hh)


#
# the library target 
#
SET(MIACORE_SRC ${MIACORE_SRC_BASE} ${ITPP_SRC} ${FFTWF_SRC} ${PWPDF_SRC})
SET(MIACORE_HEADER ${MIACORE_HEADER_BASE} ${ITPP_HEADER} ${FFTWF_HEADER} ${PWPDF_HEADER})

SET(miacore_deps miagsl ${BASELIBS} ${TBB_LIBRARIES} ${FFTWF_LIBRARIES} ${XMLPP_LIBRARIES})
MIA_ADD_LIBRARY(miacore "${MIACORE_SRC}" "${miacore_deps}")

IF(PWPDF_FOUND AND FFTWD_FOUND)
  TARGET_LINK_LIBRARIES(miacore ${PWPDF_LIBRARIES})
ENDIF(PWPDF_FOUND AND FFTWD_FOUND)

IF(ITPP_FOUND)
  TARGET_LINK_LIBRARIES(miacore ${ITPP_LIBRARIES})
ENDIF(ITPP_FOUND)

SET(MIACORE miacore ${BASELIBS})
SET_TARGET_PROPERTIES(miacore PROPERTIES 
  SOVERSION ${LIBRARY_SOVERSION_INFO}
  VERSION ${LIBRARY_VERSION_INFO}
)



#
# the test targets 
#

ADD_EXECUTABLE(test-core ${MIACORETEST_SRC})
ADD_TEST(core test-core)

TARGET_LINK_LIBRARIES(test-core ${MIACORE} ${BOOST_UNITTEST})

IF(WIN32)
  SET_TARGET_PROPERTIES(test-core PROPERTIES LINKER_FLAGS "/NODEFAULTLIB:MSVCRT")
ENDIF(WIN32)

#IF (NOT WIN32)
#  CORE_TEST(history)
#ENDIF (NOT WIN32)
#CORE_TEST(noisegen)

ADD_SUBDIRECTORY(testplug      )
ADD_SUBDIRECTORY(spacialkernel )
ADD_SUBDIRECTORY(noise         ) 
ADD_SUBDIRECTORY(minimizer     ) 
ADD_SUBDIRECTORY(splinekernel  ) 
ADD_SUBDIRECTORY(splinebc  ) 

NEW_TEST(Vector miacore)
NEW_TEST(attributes miacore)
NEW_TEST(boundary_conditions  miacore)
NEW_TEST(callback miacore)
NEW_TEST(cmdoptionflags miacore)
NEW_TEST(cmdlineparser miacore)
NEW_TEST(datapool miacore)
NEW_TEST(delayedparameter miacore)
NEW_TEST(distance miacore)
NEW_TEST(factoryoption miacore)
NEW_TEST(fftslopeclassifier miacore)
NEW_TEST(filetools miacore)
NEW_TEST(fixedwidthoutput miacore)
NEW_TEST(flagstring  miacore)
NEW_TEST(fullstats miacore)
NEW_TEST(handler miacore)
NEW_TEST(histogram miacore)
NEW_TEST(index miacore)
NEW_TEST(interpolator1d miacore)
NEW_TEST(iohandler miacore)
NEW_TEST(kmeans miacore)
NEW_TEST(labelmap miacore)
NEW_TEST(meanvar  miacore)
NEW_TEST(nccsum  miacore)
NEW_TEST(productcache  miacore)
NEW_TEST(property_flags  miacore)
NEW_TEST(scaler1d miacore)
NEW_TEST(seriesstats miacore)
NEW_TEST(singular_refobj miacore)
NEW_TEST(shape miacore)
NEW_TEST(simpson miacore)
NEW_TEST(slopeclassifier miacore)
NEW_TEST(slopestatistics miacore)
NEW_TEST(sparse_solver miacore)
NEW_TEST(splinekernel miacore)
NEW_TEST(splineparzenmi miacore)
NEW_TEST(streamvector miacore)
NEW_TEST(statistics miacore)
NEW_TEST(threadedmsg miacore)
NEW_TEST(tools miacore)
NEW_TEST(utils miacore)
#NEW_TEST(watch miacore)
NEW_TEST(waveletslopeclassifier miacore)

IF(ITPP_FOUND)
  NEW_TEST(ica miacore)
ENDIF(ITPP_FOUND)

IF(FFTWF_FOUND AND WITH_FFTWF)
  NEW_TEST(fft1d miacore)
ENDIF(FFTWF_FOUND AND WITH_FFTWF)

IF(PWPDF_FOUND) 
  NEW_TEST(pwh miacore)
ENDIF(PWPDF_FOUND) 
#
#installation 
#

INSTALL_WITH_EXPORT(miacore)
INSTALL(FILES ${MIACORE_HEADER} DESTINATION ${INCLUDE_INSTALL_PATH}/mia/core)

=== src/fluid2d/CMakeLists.txt ===
#
# This file is part of MIA - a toolbox for medical image analysis 
# Copyright (c) Leipzig, Madrid 1999-2014 Gert Wollny
#
# MIA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.
#

SET(fluid2d_SOURCES main.cc vfluid.cc elast.cc helpers.cc)

ADD_EXECUTABLE(mia-2dfluid ${fluid2d_SOURCES})
TARGET_LINK_LIBRARIES(mia-2dfluid mia2d)
MIA_EXE_CREATE_DOCU_AND_INTERFACE(mia 2dfluid)

INSTALL(TARGETS mia-2dfluid RUNTIME DESTINATION "bin")

=== src/fluid3d/CMakeLists.txt ===
#
# This file is part of MIA - a toolbox for medical image analysis 
# Copyright (c) Leipzig, Madrid 1999-2014 Gert Wollny
#
# MIA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.
#

SET(fluid3d_SOURCES 
  eqn_solver.cc
  main.cc
  sor_solver.cc
  vfluid.cc
  )
ADD_DEFINITIONS(-DVSTREAM_DOMAIN=\"fluid3d\")

ADD_EXECUTABLE(mia-3dfluid ${fluid3d_SOURCES})
TARGET_LINK_LIBRARIES(mia-3dfluid mia3d)
INSTALL(TARGETS mia-3dfluid RUNTIME DESTINATION "bin")

MIA_EXE_CREATE_DOCU_AND_INTERFACE(mia 3dfluid)

=== src/isosurface/CMakeLists.txt ===
#
# This file is part of MIA - a toolbox for medical image analysis 
# Copyright (c) Leipzig, Madrid 1999-2014 Gert Wollny
#
# MIA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.
#

SET(miagts_SOURCES 
  iso_backend.cc  mesh_convert.cc
  )

OPTION(WITH_GTS "Use the GNU Triangulated Surfaces Library for some mesh realted features" ${SEARCH_LIBS_DEFAULT})

IF(WITH_GTS) 
  IF(STRICT_DEPENDECIES) 
    pkg_check_modules(GTS gts REQUIRED)
  ELSE(STRICT_DEPENDECIES) 
    pkg_check_modules(GTS gts REQUIRED)
  ENDIF(STRICT_DEPENDECIES) 
ENDIF(WITH_GTS) 

IF(GTS_FOUND) 
  INCLUDE_DIRECTORIES(${GTS_INCLUDE_DIRS})
  set( miagts_DEPS miamesh ${GTS_LIBRARIES})
  MIA_ADD_LIBRARY(miagts "${miagts_SOURCES}" "${miagts_DEPS}")
  INSTALL_WITH_EXPORT(miagts)

  # add the ISO-surface programs 
  ADD_EXECUTABLE(mia-3disosurface-from-volume iso.cc)
  MIA_EXE_CREATE_DOCU_AND_INTERFACE(mia 3disosurface-from-volume)
  TARGET_LINK_LIBRARIES(mia-3disosurface-from-volume miagts)
  INSTALL(TARGETS mia-3disosurface-from-volume RUNTIME DESTINATION "bin")

  ADD_EXECUTABLE(mia-3disosurface-from-stack iso_from_slices.cc)
  MIA_EXE_CREATE_DOCU_AND_INTERFACE(mia 3disosurface-from-stack)
  TARGET_LINK_LIBRARIES(mia-3disosurface-from-stack miagts)
  INSTALL(TARGETS mia-3disosurface-from-stack RUNTIME DESTINATION "bin")

  # add GTS IO plug-in
  
  
ENDIF(GTS_FOUND)

=== mia/2d/filter/CMakeLists.txt ===
#
# This file is part of MIA - a toolbox for medical image analysis 
# Copyright (c) Leipzig, Madrid 1999-2014 Gert Wollny
#
# MIA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.
#

IF (FFTWF_FOUND AND WITH_FFTWF) 
  SET(filters2d_fftNew cst fft)
ENDIF (FFTWF_FOUND AND WITH_FFTWF) 

SET (NOTHING
  classmap
  frequency
  harmmean
  ianiso
  kuwahara
  lnfft
  midpoint
  rgg
  variation
  wmean
  ws
)

SET(filters2dNew_base 
  adaptmed
  admean
  aniso
  bandpass
  binarize
  combiner
  convert
  crop
  distance
  downscale
  gradnorm
  invert
  kmeans
  label 
  labelmap
  labelscale
  load
  mask
  mean 
  median
  mlv
  morphological
  ngfnorm
  noise
  regiongrow
  scale
  seededwatershed
  selectbig
  sepconv
  shaped_mean
  sortlabel
  tee
  thinning 
  thresh
  transform
  watershed
)

SET(filters2dNew ${filters2dNew_base} ${filters2d_fftNew})

PLUGINGROUP_WITH_TEST_AND_PREFIX2("2dimage" "filter" "${filters2dNew}" 
  "${MIA2DLIBS}" TESTLIBS  mia2dtest)

=== mia/2d/fullcost/CMakeLists.txt ===
#
# This file is part of MIA - a toolbox for medical image analysis 
# Copyright (c) Leipzig, Madrid 1999-2014 Gert Wollny
#
# MIA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.
#

SET(fullcost image maskedimage label)
PLUGINGROUP_WITH_TEST_AND_PREFIX2("2dimage" "fullcost" "${fullcost}" mia2dtest )

=== mia/2d/timestep/CMakeLists.txt ===
#
# This file is part of MIA - a toolbox for medical image analysis 
# Copyright (c) Leipzig, Madrid 1999-2014 Gert Wollny
#
# MIA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.
#

SET(timesteps2d
  direct
  fluid
)

PLUGINGROUP_WITH_TEST_AND_PREFIX2("2dimage" "timestep" "${timesteps2d}" mia2dtest)

=== debian/changelog ===
mia (2.2.3-2build5) wily; urgency=medium

  * No-change rebuild for hdf5 soname change.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 07 Oct 2015 11:38:18 +0000

mia (2.2.3-2build4) wily; urgency=medium

  * Rebuild for new dcmtk soname.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 03 Oct 2015 21:01:17 +0000

mia (2.2.3-2build3) wily; urgency=medium

  * No-change rebuild for libxml++ soname change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 07 Sep 2015 08:28:13 +0000

mia (2.2.3-2build2) wily; urgency=medium

  * No-change rebuild for vtk 6.2.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 30 Aug 2015 12:45:07 +0200

mia (2.2.3-2build1) wily; urgency=medium

  * No-change rebuild against libopenexr22.

 -- Martin Pitt <martin.pitt@ubuntu.com>  Thu, 06 Aug 2015 12:27:31 +0200

mia (2.2.3-2) unstable; urgency=medium

  * Backport from experimental 
  * Add patch to build with g++-5, Closes: #778005
  * Add patch to remove time stamp from Doxygen created docu
  * Add patch to correct compile problemd with g++ >= 4.9.2 

 -- Gert Wollny <gw.fossdev@gmail.com>  Fri, 29 May 2015 12:21:43 +0200

mia (2.2.3-1) experimental; urgency=medium

  * New upstream version
  * Add doctools to libmia-2.2-dev package
  * Add nipype interfaces to mia-tools package
  * Add a patch to clean up some lintian warnings in the man pages
    that didn't make it into the upstream release package. 

 -- Gert Wollny <gw.fossdev@gmail.com>  Thu, 08 Jan 2015 15:17:14 +0100

=== debian/control ===
Source: mia
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Gert Wollny <gw.fossdev@gmail.com>
Section: science
Priority: optional
Build-Depends: cmake (>= 2.8.8),
               debhelper (>= 9.0.0),
               docbook-xsl,
               doxygen,
               graphviz,
               libblas-dev,
               libboost-filesystem-dev (>= 1.46.1),
               libboost-regex-dev (>= 1.46.1),
               libboost-serialization-dev (>= 1.46.1),
               libboost-system-dev (>= 1.46.1),
               libboost-test-dev (>= 1.46.1),
               libdcmtk2-dev,
               libeigen3-dev, 
               libfftw3-dev,
               libgsl0-dev (>= 1.14),
               libgts-dev,
               libhdf5-dev, 
               libitpp-dev (>= 4.2),
               libnifti-dev, 
               libnlopt-dev (>= 2.2.3),
               libopenexr-dev (>= 1.6.1),
               libpng-dev,
               libtbb-dev (>= 3.0),
               libtiff-dev,
               libvtk6-dev,
               libvistaio-dev (>=1.2.12),
               libxml++2.6-dev (>= 2.34.1),
               python-lxml,
               xsltproc
Standards-Version: 3.9.6
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-med/mia.git
Vcs-Git: git://anonscm.debian.org/debian-med/mia.git
Homepage: http://mia.sourceforge.net

Package: libmia-2.2-dev
Architecture: any
Section: libdevel
Depends: libmia-2.2-0 (= ${binary:Version}),
         libxml++2.6-dev (>= 2.34.1),
         libeigen3-dev, 
         libitpp-dev (>= 4.2),
         libtbb-dev,
         libgsl0-dev,
         libboost-filesystem-dev (>= 1.46.1),
         libboost-regex-dev (>= 1.46.1),
         libboost-serialization-dev (>= 1.46.1),
         libboost-system-dev (>= 1.46.1),
         libboost-test-dev (>= 1.46.1),
         libfftw3-dev,
         libblas-dev,
         ${misc:Depends}
Recommends: libmia-2.2-doc
Suggests: python-lxml
Description: library for 2D and 3D gray scale image processing, development files
 libmia comprises a set of libraries and plug-ins for general purpose 
 2D and 3D gray scale image processing and basic handling of triangular 
 meshes. The libraries provide a basic infrastructure and  generic 
 algorithms, that can be specialized by specifying the apropriate plug-ins. 
 This package provides the development files for the library.

Package: libmia-2.2-doc
Architecture: all
Section: doc
Depends: ${misc:Depends},
         libjs-jquery
Enhances: libmia-2.2-dev
Replaces: libmia-2.0-doc
Breaks: libmia-2.0-doc
Description: library for 2D and 3D gray scale image processing, documentation
 libmia comprises a set of libraries and plug-ins for general purpose 
 2D and 3D gray scale image processing and basic handling of triangular 
 meshes. The libraries provide a basic infrastructure and  generic 
 algorithms, that can be specialized by specifying the apropriate plug-ins. 
 This package provides the Doxygen generated API reference. 

Package: libmia-2.2-0
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: library for 2D and 3D gray scale image processing
 libmia comprises a set of libraries and plug-ins for general purpose 
 2D and 3D gray scale image processing and basic handling of triangular 
 meshes. The libraries provide a basic infrastructure and  generic 
 algorithms, that can be specialized by specifying the apropriate plug-ins. 

Package: libmia-2.2-0-dbg
Architecture: any
Section: debug
Priority: extra
Depends: libmia-2.2-0 (= ${binary:Version}),
         ${misc:Depends}
Description: Debug information for the MIA library 
 libmia comprises a set of libraries and plug.ins for general purpose 
 2D and 3D gray scale image processing and basic handling of triangular 
 meshes. The libraries provide a basic infrastructure and  generic 
 algorithms, that can be specialized by specifying the apropriate plug-ins. 
 libmia is library for general purpouse 2D and 3D gray scale image processing. 
 This package provides the debug information of the library. 

Package: mia-tools
Architecture: any
Depends: libmia-2.2-0 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Recommends: mia-tools-doc
Suggests: python-nipype
Breaks: pymia ( <=0.1.6 )
Description: Command line tools for gray scale image processing
 Command lines tools to run general purpose image processing tasks on 2D 
 and 3D gray scale images, and basic operations on triangular meshes. 
 Supported image processing algorithms are image filtering, combining, image 
 registration, motion compensation for image series, and the estimation of 
 various statistics over images. 
 This package also contains the nipype interfaces for these command line tools. 

Package: mia-tools-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Enhances: mia-tools
Description: Cross-referenced documentation of the MIA command line tools
 Cross referenced documentation of the command line tools and plug-ins that 
 are provided by the MIA gray scale image processing tool chain. 
 These lines tools to provide the means to run general purpose image 
 processing tasks on 2D and 3D gray scale images, and basic operations on 
 triangular meshes interactively from the command line. Supported image 
 processing algorithms are image filtering, combining, image registration, 
 motion compensation for image series, and the estimation of various 
 statistics over images. 

Package: mia-tools-dbg
Architecture: any
Section: debug
Priority: extra
Depends: mia-tools (= ${binary:Version}),
         ${misc:Depends}
Description: Debugging information for the MIA command line tools
 Debug information for the MIA command lines tools. These tools provide the 
 means to run general purpose image processing tasks on 2D and 3D gray scale 
 images, and basic operations on triangular meshes from the command line. 
 Supported image processing algorithms are image filtering, combining, image 
 registration, motion compensation for image series, and the estimation of 
 various statistics over images.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed -fvisibility=hidden

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DH_ALWAYS_EXCLUDE=jquery.js

.PHONY: override_dh_strip override_dh_shlibdeps override_dh_auto_test

%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure -- \
	-DALWAYS_CREATE_DOC=ON  \
	-DSTRICT_DEPENDECIES=ON \
	-DMIA_CREATE_MANPAGES=ON \
	-DMIA_CREATE_NIPYPE_INTERFACES=ON

override_dh_builddeb:
	dh_builddeb -- -Z xz

# dh_strip detects executable files, so make *.mia files executable then strip then 
# remove the executable flag 
override_dh_strip:
	 `pwd`/debian/run_strip

override_dh_shlibdeps:
	dh_shlibdeps -- $(shell find  debian/libmia-2.2-0/ -name "*.mia")

override_dh_auto_test:
	dh_auto_test || \
		( echo "Test log begin =========:"  \
		&& cat `pwd`/obj-*/Testing/Temporary/LastTest.log \
		&& echo "Test log end =========:" \
		&& exit 1)
